Bug 1169924 - Review Request: nodejs-supports-color - Detect whether a terminal supports color
Summary: Review Request: nodejs-supports-color - Detect whether a terminal supports color
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Piotr Popieluch
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1115680
TreeView+ depends on / blocked
 
Reported: 2014-12-02 18:13 UTC by Ralph Bean
Modified: 2015-03-08 22:42 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-03-05 14:40:56 UTC
Type: ---
piotr1212: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Ralph Bean 2014-12-02 18:13:57 UTC
Spec URL: http://ralph.fedorapeople.org//nodejs-supports-color.spec
SRPM URL: http://ralph.fedorapeople.org//nodejs-supports-color-1.2.0-1.fc20.src.rpm

Description:
Detect whether a terminal supports color

Comment 1 Ralph Bean 2014-12-02 18:13:59 UTC
This package built on koji:  http://koji.fedoraproject.org/koji/taskinfo?taskID=8278790

Comment 2 Piotr Popieluch 2014-12-30 15:40:02 UTC
1. Please enable tests: 
all BR's are now in Fedora and the tests succeed here.
  Source0: http://registry.npmjs.org/%{barename}/-/%{barename}-%{version}.tgz
and in %prep
  cp -p %{SOURCE1} .



2. Cli.js executable doesn't work when run:

$ supports-color 

module.js:340
    throw err;
          ^
Error: Cannot find module './package.json'
    at Function.Module._resolveFilename (module.js:338:15)
    at Function.Module._load (module.js:280:25)
    at Module.require (module.js:364:17)
    at require (module.js:380:17)
    at Object.<anonymous> (/usr/bin/supports-color:3:11)
    at Module._compile (module.js:456:26)
    at Object.Module._extensions..js (module.js:474:10)
    at Module.load (module.js:356:32)
    at Function.Module._load (module.js:312:12)
    at Function.Module.runMain (module.js:497:10)

This can be fixed by installing cli.js into the module directory and making a symlink in /usr/bin, like this:

%install
mkdir -p %{buildroot}%{nodejs_sitelib}/supports-color
cp -pr package.json index.js cli.js \
    %{buildroot}%{nodejs_sitelib}/supports-color

mkdir -p %{buildroot}/%{_bindir}/
ln -s %{nodejs_sitelib}/supports-color/cli.js \
    %{buildroot}/%{_bindir}/supports-color



3. Please comment out %nodejs_symlink_deps --build in the %build section. I do understand that you want to keep this to keep all your node modules the same, but it gives warnings when running the tests. Commenting out would be a good compromise?

ARNING: the symlink for dependency "require-uncached" already exists

This could mean that the dependency exists in both devDependencies and 
dependencies, which may cause trouble for people using this module with npm.

Please report this to upstream. For more information, see:
    <https://github.com/tchollingsworth/nodejs-packaging/pull/1>




Looks good for the rest, you *could* add a manpage if you like. Will approve when you enable test, comment out %nodejs_symlink_deps --build and fix the cli.js symlink issue.






Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[-]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 2 files have unknown license. Detailed output of
     licensecheck in /home/piotr/rpmbuild/1169924-nodejs-supports-
     color/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[ ]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: nodejs-supports-color-1.2.0-1.fc22.noarch.rpm
          nodejs-supports-color-1.2.0-1.fc22.src.rpm
nodejs-supports-color.noarch: W: only-non-binary-in-usr-lib
nodejs-supports-color.noarch: W: no-manual-page-for-binary supports-color
2 packages and 0 specfiles checked; 0 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
]0;<mock-chroot><mock-chroot>[root@pontifex /]# rpmlint nodejs-supports-color
nodejs-supports-color.noarch: W: only-non-binary-in-usr-lib
nodejs-supports-color.noarch: W: no-manual-page-for-binary supports-color
1 packages and 0 specfiles checked; 0 errors, 2 warnings.
]0;<mock-chroot><mock-chroot>[root@pontifex /]# echo 'rpmlint-done:'



Requires
--------
nodejs-supports-color (rpmlib, GLIBC filtered):
    /usr/bin/env
    nodejs(engine)



Provides
--------
nodejs-supports-color:
    nodejs-supports-color
    npm(supports-color)



Source checksums
----------------
http://registry.npmjs.org/supports-color/-/supports-color-1.2.0.tgz :
  CHECKSUM(SHA256) this package     : 575916b4275b3b5d544e917433ce65651998fc878e9a1e020abe5b10fbec7ec8
  CHECKSUM(SHA256) upstream package : 575916b4275b3b5d544e917433ce65651998fc878e9a1e020abe5b10fbec7ec8


Generated by fedora-review 0.5.2 (63c24cb) last change: 2014-07-14
Command line :/usr/bin/fedora-review -b 1169924
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 3 Ralph Bean 2015-02-10 17:52:58 UTC
Thanks for the review, Piotr!

Here's a new release that that addresses your three comments:

Spec URL: http://threebean.org/rpm/SPECS/nodejs-supports-color.spec
SRPM URL: http://threebean.org/rpm/SRPMS/nodejs-supports-color-1.2.0-2.fc21.src.rpm

Comment 4 Piotr Popieluch 2015-02-14 21:15:43 UTC
looks good, APPROVED

Comment 5 Ralph Bean 2015-02-15 03:15:24 UTC
New Package SCM Request
=======================
Package Name: nodejs-supports-color
Short Description: Detect whether a terminal supports color
Upstream URL: https://npmjs.org/package/supports-color
Owners: ralph
Branches: f21,f20,f19,epel7
InitialCC:

Comment 6 Gwyn Ciesla 2015-02-16 14:21:15 UTC
Git done (by process-git-requests).

Swapped EOL f19 for freshly branched f22.

Comment 7 Fedora Update System 2015-02-16 16:40:48 UTC
nodejs-supports-color-1.2.0-2.el7 has been submitted as an update for Fedora EPEL 7.
https://admin.fedoraproject.org/updates/nodejs-supports-color-1.2.0-2.el7

Comment 8 Fedora Update System 2015-02-16 16:41:04 UTC
nodejs-supports-color-1.2.0-2.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/nodejs-supports-color-1.2.0-2.fc21

Comment 9 Fedora Update System 2015-02-16 16:41:14 UTC
nodejs-supports-color-1.2.0-2.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/nodejs-supports-color-1.2.0-2.fc20

Comment 10 Fedora Update System 2015-03-05 12:38:13 UTC
nodejs-supports-color-1.2.0-2.fc20 has been pushed to the Fedora 20 stable repository.

Comment 11 Fedora Update System 2015-03-05 12:39:31 UTC
nodejs-supports-color-1.2.0-2.fc21 has been pushed to the Fedora 21 stable repository.

Comment 12 Fedora Update System 2015-03-08 22:42:03 UTC
nodejs-supports-color-1.2.0-2.el7 has been pushed to the Fedora EPEL 7 stable repository.


Note You need to log in before you can comment on or make changes to this bug.